spandsp 0.0.6

v29tx.c File Reference
`#include <stdio.h>`
`#include <inttypes.h>`
`#include <stdlib.h>`
`#include <string.h>`
`#include "floating_fudge.h"`
`#include "spandsp/telephony.h"`
`#include "spandsp/fast_convert.h"`
`#include "spandsp/logging.h"`
`#include "spandsp/complex.h"`
`#include "spandsp/vector_float.h"`
`#include "spandsp/complex_vector_float.h"`
`#include "spandsp/vector_int.h"`
`#include "spandsp/complex_vector_int.h"`
`#include "spandsp/async.h"`
`#include "spandsp/dds.h"`
`#include "spandsp/power_meter.h"`
`#include "spandsp/v29tx.h"`
`#include "spandsp/private/logging.h"`
`#include "spandsp/private/v29tx.h"`
`#include "v29tx_constellation_maps.h"`
`#include "v29tx_floating_rrc.h"`

## Macros
#define | CARRIER_NOMINAL_FREQ 1700.0f
#define | V29_TRAINING_SEG_TEP 0
#define | V29_TRAINING_SEG_1 (V29_TRAINING_SEG_TEP + 480)
#define | V29_TRAINING_SEG_2 (V29_TRAINING_SEG_1 + 48)
#define | V29_TRAINING_SEG_3 (V29_TRAINING_SEG_2 + 128)
#define | V29_TRAINING_SEG_4 (V29_TRAINING_SEG_3 + 384)
#define | V29_TRAINING_END (V29_TRAINING_SEG_4 + 48)
#define | V29_TRAINING_SHUTDOWN_END (V29_TRAINING_END + 32)

## Functions
int | v29_tx (v29_tx_state_t *s, int16_t amp[], int len)
void | v29_tx_power (v29_tx_state_t *s, float power)
| Adjust a V.29 modem transmit context's output power.
void | v29_tx_set_get_bit (v29_tx_state_t *s, get_bit_func_t get_bit, void *user_data)
| Change the get_bit function associated with a V.29 modem transmit context.
void | v29_tx_set_modem_status_handler (v29_tx_state_t *s, modem_status_func_t handler, void *user_data)
| Change the modem status report function associated with a V.29 modem transmit context.
logging_state_t * | v29_tx_get_logging_state (v29_tx_state_t *s)
| Get the logging context associated with a V.29 modem transmit context.
int | v29_tx_restart (v29_tx_state_t *s, int bit_rate, int tep)
| Reinitialise an existing V.29 modem transmit context.
v29_tx_state_t * | v29_tx_init (v29_tx_state_t *s, int bit_rate, int tep, get_bit_func_t get_bit, void *user_data)
| Initialise a V.29 modem transmit context.
int | v29_tx_release (v29_tx_state_t *s)
| Release a V.29 modem transmit context.
int | v29_tx_free (v29_tx_state_t *s)
| Free a V.29 modem transmit context.

## Macro Definition Documentation

## ◆ CARRIER_NOMINAL_FREQ

#define CARRIER_NOMINAL_FREQ 1700.0f

The nominal frequency of the carrier, in Hertz

## ◆ V29_TRAINING_END

#define V29_TRAINING_END (V29_TRAINING_SEG_4 + 48)

The end of the training, in symbols

## ◆ V29_TRAINING_SEG_1

#define V29_TRAINING_SEG_1 (V29_TRAINING_SEG_TEP + 480)

The start of training segment 1, in symbols

Referenced by v29_tx_restart().

## ◆ V29_TRAINING_SEG_2

#define V29_TRAINING_SEG_2 (V29_TRAINING_SEG_1 + 48)

The start of training segment 2, in symbols

## ◆ V29_TRAINING_SEG_3

#define V29_TRAINING_SEG_3 (V29_TRAINING_SEG_2 + 128)

The start of training segment 3, in symbols

## ◆ V29_TRAINING_SEG_4

#define V29_TRAINING_SEG_4 (V29_TRAINING_SEG_3 + 384)

The start of training segment 4, in symbols

## ◆ V29_TRAINING_SEG_TEP

#define V29_TRAINING_SEG_TEP 0

The start of the optional TEP, that may preceed the actual training, in symbols

Referenced by v29_tx_restart().

## ◆ V29_TRAINING_SHUTDOWN_END

#define V29_TRAINING_SHUTDOWN_END (V29_TRAINING_END + 32)

The end of the shutdown sequence, in symbols

## Function Documentation

## ◆ v29_tx_free()

int v29_tx_free | ( | v29_tx_state_t * | s | ) |

Free a V.29 modem transmit context.

Free a V.29 modem transmit context.

Parameters

  s | The modem context.

Returns
  0 for OK

## ◆ v29_tx_get_logging_state()

logging_state_t * v29_tx_get_logging_state | ( | v29_tx_state_t * | s | ) |

Get the logging context associated with a V.29 modem transmit context.

Get the logging context associated with a V.29 modem transmit context.

Parameters

  s | The modem context.

Returns
  A pointer to the logging context

References v29_tx_state_s::logging.

## ◆ v29_tx_init()

v29_tx_state_t * v29_tx_init | ( | v29_tx_state_t * | s,
|  | int | bit_rate,
|  | int | tep,
|  | get_bit_func_t | get_bit,
|  | void * | user_data )

Initialise a V.29 modem transmit context.

Initialise a V.29 modem transmit context. This must be called before the first use of the context, to initialise its contents.

Parameters

  s | The modem context.
  bit_rate | The bit rate of the modem. Valid values are 4800, 7200 and 9600.
  tep | TRUE is the optional TEP tone is to be transmitted.
  get_bit | The callback routine used to get the data to be transmitted.
  user_data | An opaque pointer.

Returns
  A pointer to the modem context, or NULL if there was a problem.

References CARRIER_NOMINAL_FREQ, v29_tx_state_s::carrier_phase_rate, v29_tx_state_s::get_bit, v29_tx_state_s::get_bit_user_data, v29_tx_state_s::logging, v29_tx_power(), and v29_tx_restart().

## ◆ v29_tx_power()

void v29_tx_power | ( | v29_tx_state_t * | s,
|  | float | power )

Adjust a V.29 modem transmit context's output power.

Adjust a V.29 modem transmit context's power output.

Parameters

  s | The modem context.
  power | The power level, in dBm0

References v29_tx_state_s::base_gain.

Referenced by v29_tx_init().

## ◆ v29_tx_release()

int v29_tx_release | ( | v29_tx_state_t * | s | ) |

Release a V.29 modem transmit context.

Release a V.29 modem transmit context.

Parameters

  s | The modem context.

Returns
  0 for OK

## ◆ v29_tx_restart()

int v29_tx_restart | ( | v29_tx_state_t * | s,
|  | int | bit_rate,
|  | int | tep )

Reinitialise an existing V.29 modem transmit context.

Reinitialise an existing V.29 modem transmit context, so it may be reused.

Parameters

  s | The modem context.
  bit_rate | The bit rate of the modem. Valid values are 4800, 7200 and 9600.
  tep | TRUE is the optional TEP tone is to be transmitted.

Returns
  0 for OK, -1 for bad parameter

References v29_tx_state_s::baud_phase, v29_tx_state_s::bit_rate, v29_tx_state_s::carrier_phase, v29_tx_state_s::constellation_state, v29_tx_state_s::current_get_bit, v29_tx_state_s::in_training, v29_tx_state_s::logging, v29_tx_state_s::rrc_filter, v29_tx_state_s::rrc_filter_step, v29_tx_state_s::scramble_reg, span_log(), v29_tx_state_s::training_offset, v29_tx_state_s::training_scramble_reg, v29_tx_state_s::training_step, V29_TRAINING_SEG_1, and V29_TRAINING_SEG_TEP.

Referenced by v29_tx_init().

## ◆ v29_tx_set_get_bit()

void v29_tx_set_get_bit | ( | v29_tx_state_t * | s,
|  | get_bit_func_t | get_bit,
|  | void * | user_data )

Change the get_bit function associated with a V.29 modem transmit context.

Change the get_bit function associated with a V.29 modem transmit context.

Parameters

  s | The modem context.
  get_bit | The callback routine used to get the data to be transmitted.
  user_data | An opaque pointer.

References v29_tx_state_s::current_get_bit, v29_tx_state_s::get_bit, and v29_tx_state_s::get_bit_user_data.

## ◆ v29_tx_set_modem_status_handler()

void v29_tx_set_modem_status_handler | ( | v29_tx_state_t * | s,
|  | modem_status_func_t | handler,
|  | void * | user_data )

Change the modem status report function associated with a V.29 modem transmit context.

Change the modem status report function associated with a V.29 modem transmit context.

Parameters

  s | The modem context.
  handler | The callback routine used to report modem status changes.
  user_data | An opaque pointer.

References v29_tx_state_s::status_handler, and v29_tx_state_s::status_user_data.